#include <stdlib.h>
#include <string.h>
#include "global.h"

#ifndef WINDOWS
#include <SDL_syswm.h>
#endif

void do_paste(Uint8 * buffer)
{
	if (use_windowed_chat == 2)
		paste_in_input_field (buffer);
	else
		put_string_in_buffer (&input_text_line, buffer, input_text_line.len);
}

#ifdef OSX
void startpaste () 
{
	// Todo, actually fill these!
}

void finishpaste (void* event) 
{
	// Todo. This :-)
}
#else
#ifndef WINDOWS

void startpaste() {
	Display * dpy;
	Window window;
	SDL_SysWMinfo wminfo;
	Atom selection;
	Atom property;

	SDL_VERSION(&wminfo.version);
	if(SDL_GetWMInfo(&wminfo) && wminfo.subsystem==SDL_SYSWM_X11) {
		wminfo.info.x11.lock_func();

		dpy=wminfo.info.x11.display;
		window=wminfo.info.x11.window;

		/* Set selection to XA_PRIMARY to use xterm-style select,
		 * or CLIPBOARD to use Gnome-style cut'n'paste.
		 * KDE3 should use CLIPBOARD also, I'm not sure about older
		 * KDE versions */

		/* selection=XA_PRIMARY; */
		selection=XInternAtom(dpy,"CLIPBOARD",0);
		property=XInternAtom(dpy,"PASTE",0);
		XConvertSelection(dpy,selection,XA_STRING,property,window,CurrentTime);

		wminfo.info.x11.unlock_func();
	}
}

void finishpaste(XSelectionEvent event) {
	Display * dpy;
	Window window;
	SDL_SysWMinfo wminfo;
	Atom type;
	int actualformat;
	unsigned long items;
	unsigned long bytes;
	unsigned char * value;

	SDL_VERSION(&wminfo.version);
	if(SDL_GetWMInfo(&wminfo) && wminfo.subsystem==SDL_SYSWM_X11) {
		wminfo.info.x11.lock_func();

		dpy=wminfo.info.x11.display;
		window=wminfo.info.x11.window;

		if(event.property == None) {
			fprintf(stderr,"%s\n",not_ascii);
			return;
		}
		XGetWindowProperty(dpy,window,event.property,0,256,1,XA_STRING,&type,&actualformat,&items, &bytes, &value);
		if(type == XA_STRING)
			{
				do_paste(value);
			}
		wminfo.info.x11.unlock_func();
	}
}

#else

void windows_paste()
{
	OpenClipboard(NULL);

	do_paste(GetClipboardData(CF_TEXT));

	CloseClipboard();
}

#endif
#endif
